/*
 *  jDTAUS - DTAUS fileformat.
 *  Copyright (c) 2005 Christian Schulte <cs@schulte.it>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
package org.jdtaus.core.text.ri;

import javax.swing.event.EventListenerList;
import org.jdtaus.core.container.Dependency;
import org.jdtaus.core.container.Implementation;
import org.jdtaus.core.container.ModelFactory;
import org.jdtaus.core.container.Properties;
import org.jdtaus.core.container.Property;
import org.jdtaus.core.text.MessageEvent;
import org.jdtaus.core.text.MessageListener;
import org.jdtaus.core.text.spi.ApplicationLogger;

/**
 * jDTAUS Core SPI {@code ApplicationLogger} reference implementation.
 *
 * @author <a href="mailto:cs@schulte.it">Christian Schulte</a>
 * @version $Id: DefaultApplicationLogger.java 4330 2007-08-23 00:28:20Z schulte2005 $
 *
 * @see org.jdtaus.core.container.Container
 */
public final class DefaultApplicationLogger implements ApplicationLogger
{
    //--Implementation----------------------------------------------------------

// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:jdtausImplementation
    // This section is managed by jdtaus-container-mojo.

    /** Meta-data describing the implementation. */
    private static final Implementation META =
        ModelFactory.getModel().getModules().
        getImplementation(DefaultApplicationLogger.class.getName());
// </editor-fold>//GEN-END:jdtausImplementation

    //----------------------------------------------------------Implementation--
    //--Constructors------------------------------------------------------------

// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:jdtausConstructors
    // This section is managed by jdtaus-container-mojo.

    /**
     * <code>DefaultApplicationLogger</code> implementation constructor.
     *
     * @param meta Implementation meta-data.
     *
     * @throws NullPointerException if <code>meta</code> is <code>null</code>.
     */
    private DefaultApplicationLogger(final Implementation meta)
    {
        super();
        if(meta == null)
        {
            throw new NullPointerException("meta");
        }
        this.initializeProperties(meta.getProperties());
    }
    /**
     * <code>DefaultApplicationLogger</code> dependency constructor.
     *
     * @param meta dependency meta-data.
     *
     * @throws NullPointerException if <code>meta</code> is <code>null</code>.
     */
    private DefaultApplicationLogger(final Dependency meta)
    {
        super();
        if(meta == null)
        {
            throw new NullPointerException("meta");
        }
        this.initializeProperties(meta.getProperties());
    }

    /**
     * Initializes the properties of the instance.
     *
     * @param meta the property values to initialize the instance with.
     *
     * @throws NullPointerException if {@code meta} is {@code null}.
     */
    private void initializeProperties(final Properties meta)
    {
        Property p;

        if(meta == null)
        {
            throw new NullPointerException("meta");
        }

    }
// </editor-fold>//GEN-END:jdtausConstructors

    //------------------------------------------------------------Constructors--
    //--Dependencies------------------------------------------------------------

// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:jdtausDependencies
    // This section is managed by jdtaus-container-mojo.

// </editor-fold>//GEN-END:jdtausDependencies

    //------------------------------------------------------------Dependencies--
    //--Properties--------------------------------------------------------------

// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:jdtausProperties
    // This section is managed by jdtaus-container-mojo.

// </editor-fold>//GEN-END:jdtausProperties

    //--------------------------------------------------------------Properties--
    //--MessageEventSource------------------------------------------------------

    /** Holds {@code MessageListener}s. */
    private final EventListenerList listeners = new EventListenerList();

    public void addMessageListener(final MessageListener listener)
    {
        if(listener == null)
        {
            throw new NullPointerException("listener");
        }

        this.listeners.add(MessageListener.class, listener);
    }

    public void removeMessageListener(final MessageListener listener)
    {
        if(listener == null)
        {
            throw new NullPointerException("listener");
        }

        this.listeners.remove(MessageListener.class, listener);
    }

    public MessageListener[] getMessageListeners()
    {
        return (MessageListener[]) this.listeners.getListeners(
            MessageListener.class);

    }

    //------------------------------------------------------MessageEventSource--
    //--ApplicationLogger-------------------------------------------------------

    public void log(final MessageEvent e)
    {
        if(e == null)
        {
            throw new NullPointerException("e");
        }

        final Object[] listeners = this.listeners.getListenerList();
        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            if (listeners[i] == MessageListener.class)
            {
                ((MessageListener) listeners[i + 1]).onMessage(e);
            }
        }
    }

    //-------------------------------------------------------ApplicationLogger--
    //--DefaultApplicationLogger------------------------------------------------

    /** Creates a new {@code DefaultApplicationLogger} instance. */
    public DefaultApplicationLogger()
    {
        this(META);
    }

    //------------------------------------------------DefaultApplicationLogger--
}
